/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


package ch.educeth.eccapplet;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;


/**
 * Hauptframe, in den die ganze Applikation eingebettet wird (Applet 
 * und executables).
 * @author Reto Voegeli
 * zuletzt bearbeitet am 28.09.01
 */
public class EccApplet extends Applet implements ActionListener {
	private JFrame f; 
	
   public ImageIcon getImageIcon(String filename) {
      return new ImageIcon(EccApplet.class.getResource(filename));
   }

	/**
	 * Initialisation des Applets
	 */
	public void init() {
      setLayout(new GridLayout(1,1));
      f = new JFrame(EccConstants.ECC);
		f.getContentPane().add(EccController.CONTROLLER);
		f.setSize(600,740);
      JButton startButton=new JButton(getImageIcon(EccConstants.BUTTON_PIC));
      startButton.addActionListener(this);
		this.add(startButton);		
   }

	/**
	 * Fuer das Verlassen der Webseite
	 */
   public void stop() {
      f.setVisible(false);
   }

   public void actionPerformed(ActionEvent e) {
      f.setVisible(true);
   }


	/** Startpunkt, Initialisation, etc. der Applikation */
	public static void main(String[] args) {
		JFrame jf;
		jf = new JFrame(EccConstants.ECC);
		jf.getContentPane().add(EccController.CONTROLLER);
		jf.setSize(600,740);
		jf.addWindowListener (new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		jf.show();
	}	/* main */

}
