/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 

package ch.educeth.eccapplet;

import javax.swing.*;
import java.awt.*;


/**
 * Stellt den Fehler im 'mathematischen' Teil dar
 */
public class EccMathError extends JPanel {
	private Font BOLD_FONT = new Font("SansSerif", Font.BOLD, 12);
	private Font PLAIN_FONT = new Font("Monospaced", Font.PLAIN, 12);

	public  EccMathError() {
		this.setMaximumSize(new Dimension(1000, 70));
		this.setPreferredSize(new Dimension(300, 70));
	}

	public void paint(Graphics g) {
		super.paint(g);
		/* Block: Anzahl Fehler */
		int xTrans = 0;
		if (this.getSize().width < 250) {
			xTrans = 0;
		} else {
			xTrans = (int)((this.getSize().width - 250)*0.38197);
		}
		g.setFont(BOLD_FONT);
		String str3 = EccConstants.ERROR_NUMBER;
		int errors = EccController.CONTROLLER.empi.numberOfErrors();
		str3 += errors;
		g.drawString(str3, 10 + xTrans, 20);
		String str4 = EccConstants.WITH;
		g.setFont(PLAIN_FONT);
		int all = EccController.CONTROLLER.empi.getXsize()*EccController.CONTROLLER.empi.getYsize();
		str4 += all;
		str4 += EccConstants.POINTS;
		g.drawString(str4, 10 + xTrans, 40);
		String str5 = EccConstants.CORRESPOND;
		float perc = (float)errors/(float)all*100;
		String per = String.valueOf(perc);
		if (per.length() > 5) {
			per = per.substring(0, 5);
		}
		str5 += per +" %";
		g.drawString(str5, 10 + xTrans, 60);
	} /* paint */

}
