/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


package ch.educeth.eccapplet;

import java.util.Observable;


/** 
 * Diese Klasse enthaelt das Modell fuer die Fehlerwahrscheinlichkeit. 
 * Aendert sich dieses, werden die entsprechenden Observer benachrichtigt.
 */	
public class EccModelErrorProbability extends Observable {
	private int errorProbability = 0;
   
	/**
	 * Setzen der Fehlerwahrscheinlichkeit
	 * @param value Fehlerwahrscheinlichkeit
	 */
	public void setErrorProbability(int value) {
		errorProbability = value;
		setChanged();
		notifyObservers();
	}	/* setErrorProbability */

	/**
	 * Liefert die Fehlerwahrscheinlichkeit
	 * @return Fehlerwahrscheinlichkeit
	 */
	public int getErrorProbability() {
		return errorProbability;
	}	/* getErrorProbability */

}
