/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


package ch.educeth.eccapplet;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;


/**
 * Diese Klasse stellt das Originalbild dar.
 */
public class EccOriginalPicture extends JPanel {

	/** Konstruktor, generiert Instanz der Klasse */ 
	public EccOriginalPicture() {
		super();
		this.setBorder(BorderFactory.createTitledBorder(EccConstants.ORIGINAL_PIC));
	}

	/**
	 * Zeichnet das Originalbild
	 */
	public void paint(Graphics g) {	
		int squareSize = 0, temp = 0;
		int x, y, transx, transy, width, height;
		super.paint(g);
		width = this.getSize().width;
		height = this.getSize().height;
		x =  EccController.CONTROLLER.empi.getXsize();
		y =  EccController.CONTROLLER.empi.getYsize();
		squareSize = (int)((float)(width - 20)/(float)x);
		temp = (int)((float)(height - 30)/(float)y);
		if (temp < squareSize) {
			squareSize = temp;
		}
		transx = (width - squareSize*x)/2;
		transy = (height - squareSize*y)/2;
		g.setColor(Color.black);
		g.drawRect(transx - 1, transy + 4, squareSize*x + 1, squareSize*y + 1);
		for (int j = 0; j < x; j++) {
			for (int k = 0; k < y; k++) {
				Color color = new Color(0,0,0);
				color = EccController.CONTROLLER.ecmo.getOriginalColor(EccController.CONTROLLER.empi.getPicturePoint(k,j));
				g.setColor(color);
				g.fillRect(transx + j*squareSize, 5 + transy + k*squareSize, squareSize, squareSize);
			}
		}	
	}	/* paint */
	
}

