/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


package ch.educeth.eccapplet;

import java.util.Observer;
import java.util.Observable;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


/**
 * Diese Klasse ist fuer das Ausehen der Applikation besorgt. Sie wird
 * benachrichtigt, wenn sich irgendwelche Observables aendern.
 */
public class EccView extends JComponent implements Observer {
	protected JPanel mainPanel;
	private JPanel centerPanel;
	private JPanel leftPanel;
	private JPanel topLeftPanel;
	private JLabel topLeftLabel;
	protected JComboBox topLeftComboBox;
	protected JComboBox middleLeftComboBox;
	private JPanel rightPanel;
	private static JTextField statusMsg;
	protected JSlider slider;
	private EccOriginalPicture oPic;
	private EccHyperSpacePicture hypSpPic;
	private EccHyperSpaceErrorPicture hypErrPic;
	private EccDecodedPicture decPic;
	private JTabbedPane tabbedPane;
	private JPanel visPanel = new EccColorViewPanel();
	protected EccRightMath rightPanel2;
	protected JButton button1;
	protected JButton button2;
	protected JButton button3;
	protected JButton button4;
	private static JPanel ButtonPanel;
	private JPanel top;
	private JButton rightButton;

//	protected static ImageIcon icon = new ImageIcon(EccConstants.PIC_PATH);
	protected ImageIcon icon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource(EccConstants.PIC_PATH)));

	private static int picSizeX = 0, picSizeY = 0;
	

	

	/** Konstruktor, initialisiert das Aussehen */
	public EccView() {
		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());
//		mainPanel.setBorder(BorderFactory.createTitledBorder(""));
		statusMsg = new JTextField();
		statusMsg.setEditable(false);
		mainPanel.add(BorderLayout.SOUTH,statusMsg);
		centerPanel = new JPanel();
		centerPanel.setLayout(new GridLayout(1,0));
		leftPanel = new JPanel();
		leftPanel.setBorder(BorderFactory.createTitledBorder(EccConstants.LEFT_PANEL));
		leftPanel.setLayout(new BoxLayout(leftPanel, BoxLayout.Y_AXIS));
		topLeftPanel = new JPanel();
		topLeftPanel.setBorder(BorderFactory.createTitledBorder(""));
		topLeftPanel.setLayout(new GridLayout(2,1));
		topLeftLabel = new JLabel(EccConstants.PIC_CHOOSE);
		top = new JPanel(new FlowLayout());
		top.add(topLeftLabel);
//		topLeftPanel.add(topLeftLabel);
		topLeftComboBox = new JComboBox();
		topLeftComboBox.addItem(EccConstants.PIC_1);
		topLeftComboBox.addItem(EccConstants.PIC_2);
		topLeftComboBox.addItem(EccConstants.PIC_3);
		topLeftComboBox.addItem(EccConstants.PIC_4);
		topLeftComboBox.addItem(EccConstants.PIC_OWN);
		top.add(topLeftComboBox);
		topLeftPanel.add(top);
		topLeftPanel.setMaximumSize(new Dimension(1000, 100));
		leftPanel.add(topLeftPanel);
		oPic = new EccOriginalPicture();
		leftPanel.add(oPic);
		hypSpPic = new EccHyperSpacePicture();
		leftPanel.add(hypSpPic);
		slider = new JSlider();
		slider.setValue(0);
      slider.setBorder(BorderFactory.createTitledBorder(EccConstants.ERROR_PROB));
		slider.setMaximum(100);
		slider.setMajorTickSpacing(10);
		slider.setMinorTickSpacing(5);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		leftPanel.add(slider);
		rightButton = new JButton(EccConstants.NEW_SEND);
		rightButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		leftPanel.add(rightButton);
		hypErrPic = new EccHyperSpaceErrorPicture();
		leftPanel.add(hypErrPic);
		decPic = new EccDecodedPicture();
		leftPanel.add(decPic);
		
		centerPanel.add(leftPanel);
		rightPanel = new JPanel();
		rightPanel.setBorder(BorderFactory.createTitledBorder(EccConstants.RIGHT_PANEL));
		rightPanel.setLayout(new BorderLayout());
		middleLeftComboBox = new JComboBox();
		middleLeftComboBox.addItem(EccConstants.DIM_3);
		middleLeftComboBox.addItem(EccConstants.DIM_4);
		middleLeftComboBox.addItem(EccConstants.DIM_5);
		middleLeftComboBox.addItem(EccConstants.DIM_6);
		middleLeftComboBox.addItem(EccConstants.DIM_7);
		middleLeftComboBox.addItem(EccConstants.DIM_13);
		middleLeftComboBox.setSelectedIndex(4);
		middleLeftComboBox.setAlignmentX(Component.CENTER_ALIGNMENT);
		rightPanel.add(BorderLayout.NORTH, middleLeftComboBox);

		tabbedPane = new JTabbedPane();
		tabbedPane.addTab(EccConstants.VIS_PANE, visPanel);
		rightPanel2 = new EccRightMath();
		tabbedPane.addTab(EccConstants.MATH_PANE, rightPanel2);
		rightPanel.add(BorderLayout.CENTER,tabbedPane);
		
		centerPanel.add(rightPanel);
		mainPanel.add(BorderLayout.CENTER, centerPanel);		

		button1 = new JButton(icon);
		button2 = new JButton("");
		button3 = new JButton("");
		button4 = new JButton("");
		ButtonPanel = new JPanel(new GridLayout(1,4));
		ButtonPanel.add(button1);
		ButtonPanel.add(button2);
		ButtonPanel.add(button3);
		ButtonPanel.add(button4);
		topLeftPanel.add(ButtonPanel);
		ButtonPanel.setVisible(false);

	}

	/**
	 * Zeichnet je nach geaendertem Observable die entsprechenden Teile neu
	 * @param o Observable, welches sich geaendert hat
	 */
	public void update(Observable o, Object arg) {
	if (EccController.CONTROLLER != null) {
		if (o instanceof EccModelErrorProbability) {
			EccController.CONTROLLER.empi.setErrorPicture();
			EccController.CONTROLLER.empi.setDecodedPicture();
			hypErrPic.repaint();
			decPic.repaint();
			rightPanel2.repaint();
			EccView.setMessageText("");
		}
		if (o instanceof EccModelPicture) {
			EccController.CONTROLLER.empi.setErrorPicture();
			EccController.CONTROLLER.empi.setDecodedPicture();
			oPic.repaint();
			hypSpPic.repaint();
			hypErrPic.repaint();
			decPic.repaint();
			rightPanel2.repaint();
			EccView.setMessageText("");
		}
		if (o instanceof EccColorModel) {
			EccController.CONTROLLER.ecmo.setGeneratorFlag(true);
			visPanel.repaint();
			EccController.CONTROLLER.empi.setErrorPicture();
			EccController.CONTROLLER.empi.setDecodedPicture();
			hypSpPic.repaint();
			hypErrPic.repaint();
			decPic.repaint();			
			rightPanel2.repaint();		
			EccView.setMessageText("");
		}								
		}
	}	/* update */
	
	/**
	 * Schreibt eine Nachricht ins Textfeld
	 * @param text Text, der ausgegeben werden soll 
	 */
	public static void setMessageText(String text) {
		statusMsg.setText(text);
	}	/* setMessageText */

	/**
	 * Anzeigen der Buttons zum malen
	 */
	public void addButtons() {
		Color color = new Color(0,0,0);
		color = EccController.CONTROLLER.ecmo.getOriginalColor(1);
		button1.setBackground(color);
		color = EccController.CONTROLLER.ecmo.getOriginalColor(2);
		button2.setBackground(color);
		color = EccController.CONTROLLER.ecmo.getOriginalColor(3);
		button3.setBackground(color);
		color = EccController.CONTROLLER.ecmo.getOriginalColor(4);
		button4.setBackground(color);	
		ButtonPanel.setVisible(true);
	}	/* addButtons */
	
	/**
	 * Ausblenden der Buttons zum malen
	 */
	public void removeButtons() {
		if (ButtonPanel != null) {
			ButtonPanel.setVisible(false);
		}	/* removeButtons */
	}

	/**
	 * Gibt die Groesse eines kleinen, Zeichenpanels zurueck
	 */
	public int getPicX() {
		return picSizeX;
	}	/* getPicX */

	/**
	 * Setzt die Groesse eines kleinen, Zeichenpanels zurueck
	 */
	public static void setPicX(int x) {
		picSizeX = x;
	}	/* setPicX */

	/**
	 * Gibt die Groesse eines kleinen, Zeichenpanels zurueck
	 */
	public int getPicY() {
		return picSizeY;
	}	/* getPicY */

	/**
	 * Setzt die Groesse eines kleinen, Zeichenpanels zurueck
	 */
	public static void setPicY(int y) {
		picSizeY = y;
	}	/* setPicY */

	/**
	 * Hinzufuegen eines ActionListeners
	 */
 	public void addButtonListener(ActionListener a) { 
			rightButton.addActionListener(a);
	}

	/**
	 * Hinzufuegen eines ChangeListeners
	 */
	public void addSliderListener(ChangeListener c) {
		slider.addChangeListener(c);
	}

	/**
	 * Hinzufuegen eines ItemListeners
	 */
	public void addItemListener(ItemListener i) {
		topLeftComboBox.addItemListener(i);
	}

	/**
	 * Hinzufuegen eines ItemListeners
	 */
	public void addItem2Listener(ItemListener i) {
		middleLeftComboBox.addItemListener(i);
	}

	/**
	 * Hinzufuegen eines MouseListeners
	 */
	public void addMouseListener(MouseListener m) {
		oPic.addMouseListener(m);
	}

	/**
	 * Hinzufuegen eines ActionListeners
	 */
	public void addButton1Listener(ActionListener a) {
		button1.addActionListener(a);
	}
		
	/**
	 * Hinzufuegen eines ActionListeners
	 */
	public void addButton2Listener(ActionListener a) {
		button2.addActionListener(a);
	}
				
	/**
	 * Hinzufuegen eines ActionListeners
	 */
	public void addButton3Listener(ActionListener a) {
		button3.addActionListener(a);
	}
	
	/**
	 * Hinzufuegen eines ActionListeners
	 */
	public void addButton4Listener(ActionListener a) {
		button4.addActionListener(a);
	}
	
	/**
	 * Setzt das Icon beim editierbaren Bild
	 */
	public void setIcons(int button) {
		if (button == 1) {
			button1.setIcon(icon);
			button2.setIcon(null);
			button3.setIcon(null);
			button4.setIcon(null);
		} else if (button == 2) {
			button1.setIcon(null);
			button2.setIcon(icon);
			button3.setIcon(null);
			button4.setIcon(null);
		} else if (button == 3) {
			button1.setIcon(null);
			button2.setIcon(null);
			button3.setIcon(icon);
			button4.setIcon(null);
		} else if (button == 4) {
			button1.setIcon(null);
			button2.setIcon(null);
			button3.setIcon(null);
			button4.setIcon(icon);
		} else {
		}
		slider.requestFocus();
	}	/* setIcons */

}						
